diff --git a/gcc/c/c-typeck.c b/gcc/c/c-typeck.c
index 0bfc12b..ef036af 100644
--- a/gcc/c/c-typeck.c
+++ b/gcc/c/c-typeck.c
@@ -1243,7 +1243,7 @@ comp_target_types (location_t location, tree ttl, tree ttr)
   if (val == 2)
     pedwarn (location, OPT_Wpedantic, "types are not quite compatible");
 
-  if (val == 1 && enum_and_int_p && warn_cxx_compat)
+  if (val == 1 && enum_and_int_p && GCC_OPTION (warn_cxx_compat))
     warning_at (location, OPT_Wc___compat,
 		"pointer target types incompatible in C++");
 
@@ -1824,7 +1824,7 @@ array_to_pointer_conversion (location_t loc, tree exp)
   /* In C++ array compound literals are temporary objects unless they are
      const or appear in namespace scope, so they are destroyed too soon
      to use them for much of anything  (c++/53220).  */
-  if (warn_cxx_compat && TREE_CODE (exp) == COMPOUND_LITERAL_EXPR)
+  if (GCC_OPTION (warn_cxx_compat) && TREE_CODE (exp) == COMPOUND_LITERAL_EXPR)
     {
       tree decl = TREE_OPERAND (TREE_OPERAND (exp, 0), 0);
       if (!TREE_READONLY (decl) && !TREE_STATIC (decl))
@@ -2174,7 +2174,7 @@ lookup_field (tree type, tree component)
 		      /* The Plan 9 compiler permits referring
 			 directly to an anonymous struct/union field
 			 using a typedef name.  */
-		      if (flag_plan9_extensions
+		      if (GCC_OPTION (flag_plan9_extensions)
 			  && TYPE_NAME (TREE_TYPE (field)) != NULL_TREE
 			  && (TREE_CODE (TYPE_NAME (TREE_TYPE (field)))
 			      == TYPE_DECL)
@@ -2221,7 +2221,7 @@ lookup_field (tree type, tree component)
 	      /* The Plan 9 compiler permits referring directly to an
 		 anonymous struct/union field using a typedef
 		 name.  */
-	      if (flag_plan9_extensions
+	      if (GCC_OPTION (flag_plan9_extensions)
 		  && TYPE_NAME (TREE_TYPE (field)) != NULL_TREE
 		  && TREE_CODE (TYPE_NAME (TREE_TYPE (field))) == TYPE_DECL
 		  && (DECL_NAME (TYPE_NAME (TREE_TYPE (field)))
@@ -2356,7 +2356,7 @@ build_indirect_ref (location_t loc, tree ptr, ref_operator errstring)
 	  /* If a warning is issued, mark it to avoid duplicates from
 	     the backend.  This only needs to be done at
 	     warn_strict_aliasing > 2.  */
-	  if (warn_strict_aliasing > 2)
+	  if (GCC_OPTION (warn_strict_aliasing) > 2)
 	    if (strict_aliasing_warning (TREE_TYPE (TREE_OPERAND (pointer, 0)),
 					 type, TREE_OPERAND (pointer, 0)))
 	      TREE_NO_WARNING (pointer) = 1;
@@ -2428,7 +2428,7 @@ build_array_ref (location_t loc, tree array, tree index)
       || TREE_TYPE (index) == error_mark_node)
     return error_mark_node;
 
-  if (flag_cilkplus && contains_array_notation_expr (index))
+  if (GCC_OPTION (flag_cilkplus) && contains_array_notation_expr (index))
     {
       size_t rank = 0;
       if (!find_rank (loc, index, index, true, &rank))
@@ -2510,7 +2510,7 @@ build_array_ref (location_t loc, tree array, tree index)
 	    return error_mark_node;
 	}
 
-      if (pedantic)
+      if (GCC_OPTION (pedantic))
 	{
 	  tree foo = array;
 	  while (TREE_CODE (foo) == COMPONENT_REF)
@@ -2621,7 +2621,7 @@ build_external_ref (location_t loc, tree id, int fun, tree *type)
     {
       used_types_insert (TREE_TYPE (ref));
 
-      if (warn_cxx_compat
+      if (GCC_OPTION (warn_cxx_compat)
 	  && TREE_CODE (TREE_TYPE (ref)) == ENUMERAL_TYPE
 	  && C_TYPE_DEFINED_IN_STRUCT (TREE_TYPE (ref)))
 	{
@@ -2850,7 +2850,7 @@ build_function_call_vec (location_t loc, vec<location_t> arg_loc,
 
       name = DECL_NAME (function);
 
-      if (flag_tm)
+      if (GCC_OPTION (flag_tm))
 	tm_malloc_replacement (function);
       fundecl = function;
       /* Atomic functions have type checking/casting already done.  They are 
@@ -2858,7 +2858,7 @@ build_function_call_vec (location_t loc, vec<location_t> arg_loc,
       if (name && !strncmp (IDENTIFIER_POINTER (name), "__atomic_", 9))
         origtypes = NULL;
 
-      if (flag_cilkplus
+      if (GCC_OPTION (flag_cilkplus)
 	  && is_cilkplus_reduce_builtin (function))
 	origtypes = NULL;
     }
@@ -2880,7 +2880,7 @@ build_function_call_vec (location_t loc, vec<location_t> arg_loc,
   if (!(TREE_CODE (fntype) == POINTER_TYPE
 	&& TREE_CODE (TREE_TYPE (fntype)) == FUNCTION_TYPE))
     {
-      if (!flag_diagnostics_show_caret)
+      if (!GCC_OPTION (flag_diagnostics_show_caret))
 	error_at (loc,
 		  "called object %qE is not a function or function pointer",
 		  function);
@@ -3037,7 +3037,7 @@ convert_arguments (location_t loc, vec<location_t> arg_loc, tree typelist,
 	  break;
 	}
     }
-  if (flag_cilkplus && fundecl && is_cilkplus_reduce_builtin (fundecl))
+  if (GCC_OPTION (flag_cilkplus) && fundecl && is_cilkplus_reduce_builtin (fundecl))
     return vec_safe_length (values);
 
   /* Scan the given expressions and types, producing individual
@@ -3106,7 +3106,7 @@ convert_arguments (location_t loc, vec<location_t> arg_loc, tree typelist,
 
 	      /* Optionally warn about conversions that
 		 differ from the default conversions.  */
-	      if (warn_traditional_conversion || warn_traditional)
+	      if (GCC_OPTION (warn_traditional_conversion) || GCC_OPTION (warn_traditional))
 		{
 		  unsigned int formal_prec = TYPE_PRECISION (type);
 
@@ -3183,7 +3183,7 @@ convert_arguments (location_t loc, vec<location_t> arg_loc, tree typelist,
 		  /* Detect integer changing in width or signedness.
 		     These warnings are only activated with
 		     -Wtraditional-conversion, not with -Wtraditional.  */
-		  else if (warn_traditional_conversion && INTEGRAL_TYPE_P (type)
+		  else if (GCC_OPTION (warn_traditional_conversion) && INTEGRAL_TYPE_P (type)
 			   && INTEGRAL_TYPE_P (valtype))
 		    {
 		      tree would_have_been = default_conversion (val);
@@ -3265,7 +3265,7 @@ convert_arguments (location_t loc, vec<location_t> arg_loc, tree typelist,
 	  else
 	    {
 	      /* Convert `float' to `double'.  */
-	      if (warn_double_promotion && !c_inhibit_evaluation_warnings)
+	      if (GCC_OPTION (warn_double_promotion) && !c_inhibit_evaluation_warnings)
 		warning_at (arg_loc[parmnum], OPT_Wdouble_promotion,
 			 "implicit conversion from %qT to %qT when passing "
 			 "argument to function",
@@ -3366,11 +3366,11 @@ parser_build_binary_op (location_t location, enum tree_code code,
 
   /* Check for cases such as x+y<<z which users are likely
      to misinterpret.  */
-  if (warn_parentheses)
+  if (GCC_OPTION (warn_parentheses))
     warn_about_parentheses (location, code, code1, arg1.value, code2,
 			    arg2.value);
 
-  if (warn_logical_op)
+  if (GCC_OPTION (warn_logical_op))
     warn_logical_operator (location, code, TREE_TYPE (result.value),
 			   code1, arg1.value, code2, arg2.value);
 
@@ -3394,7 +3394,7 @@ parser_build_binary_op (location_t location, enum tree_code code,
     overflow_warning (location, result.value);
 
   /* Warn about comparisons of different enum types.  */
-  if (warn_enum_compare
+  if (GCC_OPTION (warn_enum_compare)
       && TREE_CODE_CLASS (code) == tcc_comparison
       && TREE_CODE (type1) == ENUMERAL_TYPE
       && TREE_CODE (type2) == ENUMERAL_TYPE
@@ -3672,7 +3672,7 @@ build_atomic_assign (location_t loc, tree lhs, enum tree_code modifycode,
 
   /* Create the expressions for floating-point environment
      manipulation, if required.  */
-  bool need_fenv = (flag_trapping_math
+  bool need_fenv = (GCC_OPTION (flag_trapping_math)
 		    && (FLOAT_TYPE_P (lhs_type) || FLOAT_TYPE_P (rhs_type)));
   tree hold_call = NULL_TREE, clear_call = NULL_TREE, update_call = NULL_TREE;
   if (need_fenv)
@@ -3924,7 +3924,7 @@ build_unary_op (location_t location,
 				    : lv_decrement)))
 	return error_mark_node;
 
-      if (warn_cxx_compat && TREE_CODE (TREE_TYPE (arg)) == ENUMERAL_TYPE)
+      if (GCC_OPTION (warn_cxx_compat) && TREE_CODE (TREE_TYPE (arg)) == ENUMERAL_TYPE)
 	{
 	  if (code == PREINCREMENT_EXPR || code == POSTINCREMENT_EXPR)
 	    warning_at (location, OPT_Wc___compat,
@@ -4464,7 +4464,7 @@ build_conditional_expr (location_t colon_loc, tree ifexp, bool ifexp_bcp,
 	}
     }
 
-  if (warn_cxx_compat)
+  if (GCC_OPTION (warn_cxx_compat))
     {
       tree t1 = op1_original_type ? op1_original_type : TREE_TYPE (orig_op1);
       tree t2 = op2_original_type ? op2_original_type : TREE_TYPE (orig_op2);
@@ -4544,7 +4544,7 @@ build_conditional_expr (location_t colon_loc, tree ifexp, bool ifexp_bcp,
 		  c_inhibit_evaluation_warnings
 		    -= (ifexp == truthvalue_true_node);
 
-		  if (warn_sign_compare)
+		  if (GCC_OPTION (warn_sign_compare))
 		    {
 		      if ((unsigned_op2
 			   && tree_expr_nonnegative_warnv_p (op1, &ovf))
@@ -4723,7 +4723,7 @@ build_compound_expr (location_t loc, tree expr1, tree expr2)
   tree eptype = NULL_TREE;
   tree ret;
 
-  if (flag_cilkplus
+  if (GCC_OPTION (flag_cilkplus)
       && (TREE_CODE (expr1) == CILK_SPAWN_STMT
 	  || TREE_CODE (expr2) == CILK_SPAWN_STMT))
     {
@@ -4751,7 +4751,7 @@ build_compound_expr (location_t loc, tree expr1, tree expr2)
       /* The left-hand operand of a comma expression is like an expression
 	 statement: with -Wunused, we should warn if it doesn't have
 	 any side-effects, unless it was explicitly cast to (void).  */
-      if (warn_unused_value)
+      if (GCC_OPTION (warn_unused_value))
 	{
 	  if (VOID_TYPE_P (TREE_TYPE (expr1))
 	      && CONVERT_EXPR_P (expr1))
@@ -4766,7 +4766,7 @@ build_compound_expr (location_t loc, tree expr1, tree expr2)
 	}
     }
   else if (TREE_CODE (expr1) == COMPOUND_EXPR
-	   && warn_unused_value)
+	   && GCC_OPTION (warn_unused_value))
     {
       tree r = expr1;
       location_t cloc = loc;
@@ -4787,7 +4787,7 @@ build_compound_expr (location_t loc, tree expr1, tree expr2)
      side-effects, but computes a value which is not used.  For example, in
      `foo() + bar(), baz()' the result of the `+' operator is not used,
      so we should issue a warning.  */
-  else if (warn_unused_value)
+  else if (GCC_OPTION (warn_unused_value))
     warn_if_unused_value (expr1, loc);
 
   if (expr2 == error_mark_node)
@@ -4993,7 +4993,7 @@ build_c_cast (location_t loc, tree type, tree expr)
       otype = TREE_TYPE (value);
 
       /* Optionally warn about potentially worrisome casts.  */
-      if (warn_cast_qual
+      if (GCC_OPTION (warn_cast_qual)
 	  && TREE_CODE (type) == POINTER_TYPE
 	  && TREE_CODE (otype) == POINTER_TYPE)
 	handle_warn_cast_qual (loc, type, otype);
@@ -5069,13 +5069,13 @@ build_c_cast (location_t loc, tree type, tree expr)
 		    OPT_Wint_to_pointer_cast, "cast to pointer from integer "
 		    "of different size");
 
-      if (warn_strict_aliasing <= 2)
+      if (GCC_OPTION (warn_strict_aliasing) <= 2)
         strict_aliasing_warning (otype, type, expr);
 
       /* If pedantic, warn for conversions between function and object
 	 pointer types, except for converting a null pointer constant
 	 to function pointer type.  */
-      if (pedantic
+      if (GCC_OPTION (pedantic)
 	  && TREE_CODE (type) == POINTER_TYPE
 	  && TREE_CODE (otype) == POINTER_TYPE
 	  && TREE_CODE (TREE_TYPE (otype)) == FUNCTION_TYPE
@@ -5083,7 +5083,7 @@ build_c_cast (location_t loc, tree type, tree expr)
 	pedwarn (loc, OPT_Wpedantic, "ISO C forbids "
 		 "conversion of function pointer to object pointer type");
 
-      if (pedantic
+      if (GCC_OPTION (pedantic)
 	  && TREE_CODE (type) == POINTER_TYPE
 	  && TREE_CODE (otype) == POINTER_TYPE
 	  && TREE_CODE (TREE_TYPE (type)) == FUNCTION_TYPE
@@ -5148,14 +5148,14 @@ c_cast_expr (location_t loc, struct c_type_name *type_name, tree expr)
   tree type_expr = NULL_TREE;
   bool type_expr_const = true;
   tree ret;
-  int saved_wsp = warn_strict_prototypes;
+  int saved_wsp = GCC_OPTION (warn_strict_prototypes);
 
   /* This avoids warnings about unprototyped casts on
      integers.  E.g. "#define SIG_DFL (void(*)())0".  */
   if (TREE_CODE (expr) == INTEGER_CST)
-    warn_strict_prototypes = 0;
+    GCC_OPTION (warn_strict_prototypes) = 0;
   type = groktypename (type_name, &type_expr, &type_expr_const);
-  warn_strict_prototypes = saved_wsp;
+  GCC_OPTION (warn_strict_prototypes) = saved_wsp;
 
   ret = build_c_cast (loc, type, expr);
   if (type_expr)
@@ -5173,7 +5173,7 @@ c_cast_expr (location_t loc, struct c_type_name *type_name, tree expr)
 
   /* C++ does not permits types to be defined in a cast, but it
      allows references to incomplete types.  */
-  if (warn_cxx_compat && type_name->specs->typespec_kind == ctsk_tagdef)
+  if (GCC_OPTION (warn_cxx_compat) && type_name->specs->typespec_kind == ctsk_tagdef)
     warning_at (loc, OPT_Wc___compat,
 		"defining a type in a cast is invalid in C++");
 
@@ -5329,7 +5329,7 @@ build_modify_expr (location_t location, tree lhs, tree lhs_origtype,
   /* Issue -Wc++-compat warnings about an assignment to an enum type
      when LHS does not have its original type.  This happens for,
      e.g., an enum bitfield in a struct.  */
-  if (warn_cxx_compat
+  if (GCC_OPTION (warn_cxx_compat)
       && lhs_origtype != NULL_TREE
       && lhs_origtype != lhstype
       && TREE_CODE (lhs_origtype) == ENUMERAL_TYPE)
@@ -5373,7 +5373,7 @@ build_modify_expr (location_t location, tree lhs, tree lhs_origtype,
     }
 
   /* Emit ObjC write barrier, if necessary.  */
-  if (c_dialect_objc () && flag_objc_gc)
+  if (c_dialect_objc () && GCC_OPTION (flag_objc_gc))
     {
       result = objc_generate_write_barrier (lhs, modifycode, newrhs);
       if (result)
@@ -5665,7 +5665,7 @@ convert_for_assignment (location_t location, location_t expr_loc, tree type,
       objc_ok = objc_compare_types (type, rhstype, parmno, rname);
     }
 
-  if (warn_cxx_compat)
+  if (GCC_OPTION (warn_cxx_compat))
     {
       tree checktype = origtype != NULL_TREE ? origtype : rhstype;
       if (checktype != error_mark_node
@@ -5903,7 +5903,7 @@ convert_for_assignment (location_t location, location_t expr_loc, tree type,
       /* The Plan 9 compiler permits a pointer to a struct to be
 	 automatically converted into a pointer to an anonymous field
 	 within the struct.  */
-      if (flag_plan9_extensions
+      if (GCC_OPTION (flag_plan9_extensions)
 	  && (TREE_CODE (mvl) == RECORD_TYPE || TREE_CODE(mvl) == UNION_TYPE)
 	  && (TREE_CODE (mvr) == RECORD_TYPE || TREE_CODE(mvr) == UNION_TYPE)
 	  && mvl != mvr)
@@ -5963,7 +5963,7 @@ convert_for_assignment (location_t location, location_t expr_loc, tree type,
 
       /* Check if the right-hand side has a format attribute but the
 	 left-hand side doesn't.  */
-      if (warn_suggest_attribute_format
+      if (GCC_OPTION (warn_suggest_attribute_format)
 	  && check_missing_format_attribute (type, rhstype))
 	{
 	  switch (errtype)
@@ -6007,7 +6007,7 @@ convert_for_assignment (location_t location, location_t expr_loc, tree type,
 		  == c_common_signed_type (mvr))
 	      && TYPE_ATOMIC (mvl) == TYPE_ATOMIC (mvr)))
 	{
-	  if (pedantic
+	  if (GCC_OPTION (pedantic)
 	      && ((VOID_TYPE_P (ttl) && TREE_CODE (ttr) == FUNCTION_TYPE)
 		  ||
 		  (VOID_TYPE_P (ttr)
@@ -6049,7 +6049,7 @@ convert_for_assignment (location_t location, location_t expr_loc, tree type,
 		       || target_cmp)
 		;
 	      /* If there is a mismatch, do warn.  */
-	      else if (warn_pointer_sign)
+	      else if (GCC_OPTION (warn_pointer_sign))
 		WARN_FOR_ASSIGNMENT (location, OPT_Wpointer_sign,
 				     G_("pointer targets in passing argument "
 					"%d of %qE differ in signedness"),
@@ -6447,7 +6447,7 @@ warning_init (int opt, const char *gmsgid)
 void
 maybe_warn_string_init (tree type, struct c_expr expr)
 {
-  if (pedantic
+  if (GCC_OPTION (pedantic)
       && TREE_CODE (type) == ARRAY_TYPE
       && TREE_CODE (expr.value) == STRING_CST
       && expr.original_code != STRING_CST)
@@ -6576,7 +6576,7 @@ digest_init (location_t init_loc, tree type, tree init, tree origtype,
 		pedwarn_init (init_loc, 0,
 			      ("initializer-string for array of chars "
 			       "is too long"));
-	      else if (warn_cxx_compat
+	      else if (GCC_OPTION (warn_cxx_compat)
 		       && 0 > compare_tree_int (TYPE_SIZE_UNIT (type), len))
 		warning_at (init_loc, OPT_Wc___compat,
 			    ("initializer-string for array chars "
@@ -6627,7 +6627,7 @@ digest_init (location_t init_loc, tree type, tree init, tree origtype,
 	}
     }
 
-  if (warn_sequence_point)
+  if (GCC_OPTION (warn_sequence_point))
     verify_sequence_points (inside_init);
 
   /* Any type can be initialized
@@ -6688,7 +6688,7 @@ digest_init (location_t init_loc, tree type, tree init, tree origtype,
       /* Compound expressions can only occur here if -Wpedantic or
 	 -pedantic-errors is specified.  In the later case, we always want
 	 an error.  In the former case, we simply want a warning.  */
-      if (require_constant && pedantic
+      if (require_constant && GCC_OPTION (pedantic)
 	  && TREE_CODE (inside_init) == COMPOUND_EXPR)
 	{
 	  inside_init
@@ -6699,7 +6699,7 @@ digest_init (location_t init_loc, tree type, tree init, tree origtype,
 	  else
 	    pedwarn_init (init_loc, OPT_Wpedantic,
 			  "initializer element is not constant");
-	  if (flag_pedantic_errors)
+	  if (GCC_OPTION (flag_pedantic_errors))
 	    inside_init = error_mark_node;
 	}
       else if (require_constant
@@ -6967,7 +6967,7 @@ start_init (tree decl, tree asmspec_tree ATTRIBUTE_UNUSED, int top_level)
     {
       require_constant_value = TREE_STATIC (decl);
       require_constant_elements
-	= ((TREE_STATIC (decl) || (pedantic && !flag_isoc99))
+	= ((TREE_STATIC (decl) || (GCC_OPTION (pedantic) && !flag_isoc99))
 	   /* For a scalar, you can always use any value to initialize,
 	      even within braces.  */
 	   && (TREE_CODE (TREE_TYPE (decl)) == ARRAY_TYPE
@@ -7278,7 +7278,7 @@ push_init_level (int implicit, struct obstack * braced_init_obstack)
 	set_nonincremental_init (braced_init_obstack);
     }
 
-  if (implicit == 1 && warn_missing_braces && !missing_braces_mentioned)
+  if (implicit == 1 && GCC_OPTION (warn_missing_braces) && !missing_braces_mentioned)
     {
       missing_braces_mentioned = 1;
       warning_init (OPT_Wmissing_braces, "missing braces around initializer");
@@ -7416,7 +7416,7 @@ pop_init_level (int implicit, struct obstack * braced_init_obstack)
     }
 
   /* Warn when some struct elements are implicitly initialized to zero.  */
-  if (warn_missing_field_initializers
+  if (GCC_OPTION (warn_missing_field_initializers)
       && constructor_type
       && TREE_CODE (constructor_type) == RECORD_TYPE
       && constructor_unfilled_fields)
@@ -7782,7 +7782,7 @@ add_pending_init (tree purpose, tree value, tree origtype, bool implicit,
 		{
 		  if (TREE_SIDE_EFFECTS (p->value))
 		    warning_init (0, "initialized field with side-effects overwritten");
-		  else if (warn_override_init)
+		  else if (GCC_OPTION (warn_override_init))
 		    warning_init (OPT_Woverride_init, "initialized field overwritten");
 		}
 	      p->value = value;
@@ -7809,7 +7809,7 @@ add_pending_init (tree purpose, tree value, tree origtype, bool implicit,
 		{
 		  if (TREE_SIDE_EFFECTS (p->value))
 		    warning_init (0, "initialized field with side-effects overwritten");
-		  else if (warn_override_init)
+		  else if (GCC_OPTION (warn_override_init))
 		    warning_init (OPT_Woverride_init, "initialized field overwritten");
 		}
 	      p->value = value;
@@ -8249,7 +8249,7 @@ output_init_element (tree value, tree origtype, bool strict_string, tree type,
 
   /* Issue -Wc++-compat warnings about initializing a bitfield with
      enum type.  */
-  if (warn_cxx_compat
+  if (GCC_OPTION (warn_cxx_compat)
       && field != NULL_TREE
       && TREE_CODE (field) == FIELD_DECL
       && DECL_BIT_FIELD_TYPE (field) != NULL_TREE
@@ -8336,7 +8336,7 @@ output_init_element (tree value, tree origtype, bool strict_string, tree type,
 	  if (TREE_SIDE_EFFECTS (constructor_elements->last ().value))
 	    warning_init (0,
 			  "initialized field with side-effects overwritten");
-	  else if (warn_override_init)
+	  else if (GCC_OPTION (warn_override_init))
 	    warning_init (OPT_Woverride_init, "initialized field overwritten");
 	}
 
@@ -9127,7 +9127,7 @@ c_finish_return (location_t loc, tree retval, tree origtype)
     warning_at (loc, 0,
 		"function declared %<noreturn%> has a %<return%> statement");
 
-  if (flag_cilkplus && contains_array_notation_expr (retval))
+  if (GCC_OPTION (flag_cilkplus) && contains_array_notation_expr (retval))
     {
       /* Array notations are allowed in a return statement if it is inside a
 	 built-in array notation reduction function.  */
@@ -9140,7 +9140,7 @@ c_finish_return (location_t loc, tree retval, tree origtype)
 	  return error_mark_node;
 	}
     }
-  if (flag_cilkplus && retval && contains_cilk_spawn_stmt (retval))
+  if (GCC_OPTION (flag_cilkplus) && retval && contains_cilk_spawn_stmt (retval))
     {
       error_at (loc, "use of %<_Cilk_spawn%> in a return statement is not "
 		"allowed");
@@ -9163,7 +9163,7 @@ c_finish_return (location_t loc, tree retval, tree origtype)
   if (!retval)
     {
       current_function_returns_null = 1;
-      if ((warn_return_type || flag_isoc99)
+      if ((GCC_OPTION (warn_return_type) || flag_isoc99)
 	  && valtype != 0 && TREE_CODE (valtype) != VOID_TYPE)
 	{
 	  pedwarn_c99 (loc, flag_isoc99 ? 0 : OPT_Wreturn_type,
@@ -9260,7 +9260,7 @@ c_finish_return (location_t loc, tree retval, tree origtype)
       retval = build2 (MODIFY_EXPR, TREE_TYPE (res), res, t);
       SET_EXPR_LOCATION (retval, loc);
 
-      if (warn_sequence_point)
+      if (GCC_OPTION (warn_sequence_point))
 	verify_sequence_points (retval);
     }
 
@@ -9339,7 +9339,7 @@ c_start_case (location_t switch_loc,
 	  exp = c_fully_fold (exp, false, NULL);
 	  exp = default_conversion (exp);
 
-	  if (warn_sequence_point)
+	  if (GCC_OPTION (warn_sequence_point))
 	    verify_sequence_points (exp);
 	}
     }
@@ -9441,7 +9441,7 @@ c_finish_if_stmt (location_t if_locus, tree cond, tree then_block,
      else_block must be either 0 or be equal to the rank of the condition.  If
      the condition does not have array notations then break them up as it is
      broken up in a normal expression.  */
-  if (flag_cilkplus && contains_array_notation_expr (cond))
+  if (GCC_OPTION (flag_cilkplus) && contains_array_notation_expr (cond))
     {
       size_t then_rank = 0, cond_rank = 0, else_rank = 0;
       if (!find_rank (if_locus, cond, cond, true, &cond_rank))
@@ -9466,7 +9466,7 @@ c_finish_if_stmt (location_t if_locus, tree cond, tree then_block,
 	}
     }
   /* Diagnose an ambiguous else if if-then-else is nested inside if-then.  */
-  if (warn_parentheses && nested_if && else_block == NULL)
+  if (GCC_OPTION (warn_parentheses) && nested_if && else_block == NULL)
     {
       tree inner_if = then_block;
 
@@ -9516,7 +9516,7 @@ c_finish_loop (location_t start_locus, tree cond, tree incr, tree body,
 {
   tree entry = NULL, exit = NULL, t;
 
-  if (flag_cilkplus && contains_array_notation_expr (cond))
+  if (GCC_OPTION (flag_cilkplus) && contains_array_notation_expr (cond))
     {
       error_at (start_locus, "array notation expression cannot be used in a "
 		"loop%'s condition");
@@ -9690,7 +9690,7 @@ c_process_expr_stmt (location_t loc, tree expr)
 
   expr = c_fully_fold (expr, false, NULL);
 
-  if (warn_sequence_point)
+  if (GCC_OPTION (warn_sequence_point))
     verify_sequence_points (expr);
 
   if (TREE_TYPE (expr) != error_mark_node
@@ -9702,7 +9702,7 @@ c_process_expr_stmt (location_t loc, tree expr)
      Warnings for statement expressions will be emitted later, once we figure
      out which is the result.  */
   if (!STATEMENT_LIST_STMT_EXPR (cur_stmt_list)
-      && warn_unused_value)
+      && GCC_OPTION (warn_unused_value))
     emit_side_effect_warnings (loc, expr);
 
   exprv = expr;
@@ -9793,7 +9793,7 @@ c_finish_stmt_expr (location_t loc, tree body)
 
       /* If we're supposed to generate side effects warnings, process
 	 all of the statements except the last.  */
-      if (warn_unused_value)
+      if (GCC_OPTION (warn_unused_value))
 	{
 	  for (i = tsi_start (last); !tsi_one_before_end_p (i); tsi_next (&i))
 	    {
@@ -10066,12 +10066,12 @@ build_binary_op (location_t location, enum tree_code code,
   /* When Cilk Plus is enabled and there are array notations inside op0, then
      we check to see if there are builtin array notation functions.  If
      so, then we take on the type of the array notation inside it.  */
-  if (flag_cilkplus && contains_array_notation_expr (op0)) 
+  if (GCC_OPTION (flag_cilkplus) && contains_array_notation_expr (op0)) 
     orig_type0 = type0 = find_correct_array_notation_type (op0);
   else
     orig_type0 = type0 = TREE_TYPE (op0);
 
-  if (flag_cilkplus && contains_array_notation_expr (op1))
+  if (GCC_OPTION (flag_cilkplus) && contains_array_notation_expr (op1))
     orig_type1 = type1 = find_correct_array_notation_type (op1);
   else 
     orig_type1 = type1 = TREE_TYPE (op1);
@@ -10561,13 +10561,13 @@ build_binary_op (location_t location, enum tree_code code,
 	    }
 	  else if (VOID_TYPE_P (tt0) && !TYPE_ATOMIC (tt0))
 	    {
-	      if (pedantic && TREE_CODE (tt1) == FUNCTION_TYPE)
+	      if (GCC_OPTION (pedantic) && TREE_CODE (tt1) == FUNCTION_TYPE)
 		pedwarn (location, OPT_Wpedantic, "ISO C forbids "
 			 "comparison of %<void *%> with function pointer");
 	    }
 	  else if (VOID_TYPE_P (tt1) && !TYPE_ATOMIC (tt1))
 	    {
-	      if (pedantic && TREE_CODE (tt0) == FUNCTION_TYPE)
+	      if (GCC_OPTION (pedantic) && TREE_CODE (tt0) == FUNCTION_TYPE)
 		pedwarn (location, OPT_Wpedantic, "ISO C forbids "
 			 "comparison of %<void *%> with function pointer");
 	    }
@@ -10671,20 +10671,20 @@ build_binary_op (location_t location, enum tree_code code,
       else if (code0 == POINTER_TYPE && null_pointer_constant_p (orig_op1))
 	{
 	  result_type = type0;
-	  if (pedantic)
+	  if (GCC_OPTION (pedantic))
 	    pedwarn (location, OPT_Wpedantic,
 		     "ordered comparison of pointer with integer zero");
-	  else if (extra_warnings)
+	  else if (GCC_OPTION (extra_warnings))
 	    warning_at (location, OPT_Wextra,
 			"ordered comparison of pointer with integer zero");
 	}
       else if (code1 == POINTER_TYPE && null_pointer_constant_p (orig_op0))
 	{
 	  result_type = type1;
-	  if (pedantic)
+	  if (GCC_OPTION (pedantic))
 	    pedwarn (location, OPT_Wpedantic,
 		     "ordered comparison of pointer with integer zero");
-	  else if (extra_warnings)
+	  else if (GCC_OPTION (extra_warnings))
 	    warning_at (location, OPT_Wextra,
 			"ordered comparison of pointer with integer zero");
 	}
@@ -10743,7 +10743,7 @@ build_binary_op (location_t location, enum tree_code code,
 	      || code == MULT_EXPR
 	      || (code == TRUNC_DIV_EXPR && first_complex))
 	  && TREE_CODE (TREE_TYPE (result_type)) == REAL_TYPE
-	  && flag_signed_zeros)
+	  && GCC_OPTION (flag_signed_zeros))
 	{
 	  /* An operation on mixed real/complex operands must be
 	     handled specially, but the language-independent code can
@@ -10927,7 +10927,7 @@ build_binary_op (location_t location, enum tree_code code,
 						  NULL);
 		}
 
-	      if (warn_sign_compare)
+	      if (GCC_OPTION (warn_sign_compare))
 		warn_for_sign_compare (location, orig_op0_folded,
 				       orig_op1_folded, op0, op1,
 				       result_type, resultcode);
@@ -10978,7 +10978,7 @@ build_binary_op (location_t location, enum tree_code code,
 	return error_mark_node;
     }
 
-  if ((flag_sanitize & (SANITIZE_SHIFT | SANITIZE_DIVIDE))
+  if ((GCC_OPTION (flag_sanitize) & (SANITIZE_SHIFT | SANITIZE_DIVIDE))
       && current_function_decl != 0
       && !lookup_attribute ("no_sanitize_undefined",
 			    DECL_ATTRIBUTES (current_function_decl))
@@ -10989,9 +10989,9 @@ build_binary_op (location_t location, enum tree_code code,
       op1 = c_save_expr (op1);
       op0 = c_fully_fold (op0, false, NULL);
       op1 = c_fully_fold (op1, false, NULL);
-      if (doing_div_or_mod && (flag_sanitize & SANITIZE_DIVIDE))
+      if (doing_div_or_mod && (GCC_OPTION (flag_sanitize) & SANITIZE_DIVIDE))
 	instrument_expr = ubsan_instrument_division (location, op0, op1);
-      else if (doing_shift && (flag_sanitize & SANITIZE_SHIFT))
+      else if (doing_shift && (GCC_OPTION (flag_sanitize) & SANITIZE_SHIFT))
 	instrument_expr = ubsan_instrument_shift (location, code, op0, op1);
     }
 
@@ -12289,7 +12289,7 @@ c_build_qualified_type (tree type, int type_quals)
 tree
 c_build_va_arg (location_t loc, tree expr, tree type)
 {
-  if (warn_cxx_compat && TREE_CODE (type) == ENUMERAL_TYPE)
+  if (GCC_OPTION (warn_cxx_compat) && TREE_CODE (type) == ENUMERAL_TYPE)
     warning_at (loc, OPT_Wc___compat,
 		"C++ requires promoted type, not enum type, in %<va_arg%>");
   return build_va_arg (loc, expr, type);
diff --git a/gcc/caller-save.c b/gcc/caller-save.c
index 59917a8..4dc67d4 100644
--- a/gcc/caller-save.c
+++ b/gcc/caller-save.c
@@ -378,7 +378,7 @@ saved_hard_reg_compare_func (const void *v1p, const void *v2p)
   const struct saved_hard_reg *p1 = *(struct saved_hard_reg * const *) v1p;
   const struct saved_hard_reg *p2 = *(struct saved_hard_reg * const *) v2p;
 
-  if (flag_omit_frame_pointer)
+  if (GCC_OPTION (flag_omit_frame_pointer))
     {
       if (p1->call_freq - p2->call_freq != 0)
 	return p1->call_freq - p2->call_freq;
@@ -494,7 +494,7 @@ setup_save_areas (void)
     }
 
   /* If requested, figure out which hard regs can share save slots.  */
-  if (optimize && flag_ira_share_save_slots)
+  if (GCC_OPTION (optimize) && GCC_OPTION (flag_ira_share_save_slots))
     {
       rtx slot;
       char *saved_reg_conflicts;
